/* Program to Locate a pattern within a given set of numbers */
/*
  Brief Explanation for Purpose of Program:
  There are two SETS of numbers - the SUPERSET & the SUBSET - both are taken as
  I/P from user or Randomly Generated. Now, the program verifies whether the
  SUBSET matrix is completely present within the SUPERSET matrix in a continuous
  manner. Wrap-Arounds might be permissible. Refer associated documentation
  for more details (documentation in progress)
*/

/*
  NOTE 1: Temporary Debugging Statements (TDS):
  To all programmers who might want to understand the code in greater detail,
  especially the manner of looping & breaking, uncommenting the various TDS's
  might be of great help. The various TDS's might seem cryptic to you, so I suggest
  once you figure out roughly whats going on, you can form more apt TDS's.
  For those of you, who make extensive use of compiler provided Break-points,
  these TDS's are pretty much redundant & you may ignore/delete them.
*/

/* SOURCE CODE */
/* INCLUSION DIRECTIVES */
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

/* Symbolic Constants */
const int RESET = -1;
const unsigned int MAXNUM = 10 , SUP_ROW = 1 , SUP_COL = 2 , SUB_ROW = 3 , SUB_COL = 4;
const bool COMPLETE = true , INCOMPLETE = false;
const char NEVEREXEC[] = "\n\n\aThis must never Execute!! If it does, please check the program for logical Errors!! \a\n\n";

/* Structure Declarations */
struct MatchMaking
  {
  bool subrowmatch;
  unsigned int suprowindex;
  unsigned int supcolstart,supcolend;
  };

/* Global Variables */
int **superset,**subset;
unsigned int suprow,supcol,subrow,subcol;
struct MatchMaking *match;
bool strictness = true;

/* Function Prototype Declarations */
void getInputs(void);
void allocateMemory(void);
void patMatch(void);
bool compareThreeElements(unsigned int,unsigned int,unsigned int);
unsigned int modIncr(unsigned int, unsigned int , unsigned int =1);

// Temporary Debugging Routines
// Remove these function definitions & associated function calls without
// changing core logic/functionality of the program
void dispMats(void);
void dispStub(char*);

/* MAIN FUNCTION */
void main()
  {
  getInputs();
  dispMats();
  patMatch();
  }


/* FUNCTION DEFINITIONS */
void getInputs(void)
  {
  unsigned int i,j;
  char uch1;

  clrscr();
  printf("Enter No. of Rows & Columns of SUPER-SET :  ");
  scanf("%d %d",&suprow,&supcol);

  printf("Enter No. of Rows & Columns of SUB-SET :  ");
  scanf("%d %d",&subrow,&subcol);

  if(suprow < subrow || supcol < supcol)
    {
    printf("\n\n\aDIMENSION ERROR!! Please Try Again! Program Terminates!\a\n\n");
    getch();
    exit(1);
    }

  allocateMemory();

  printf("Do you wish to Enter Values (Y/y) or Randomize the Matrix (N/n)? :  ");
  flushall();scanf("%c",&uch1);

  if(uch1 == 'y' || uch1 == 'Y')
    {
    clrscr();
    printf("Enter SUPER-SET Matrix:\n");
    for(i=0;i<suprow;i++)
      for(j=0;j<supcol;j++)
        scanf("%d",&superset[i][j]);

    printf("\n\n\n\n");
    printf("Enter SUB-SET Matrix:\n");
    for(i=0;i<subrow;i++)
      for(j=0;j<subcol;j++)
        scanf("%d",&subset[i][j]);
    }
  else
    {
    // Seeding Random Number Generator
    randomize();

    // Randomly Generating SUPER-SET Matrix
    for(i=0;i<suprow;i++)
      for(j=0;j<supcol;j++)
        superset[i][j] = random(MAXNUM);

    // Randomly Generating SUB-SET Matrix
    for(i=0;i<subrow;i++)
      for(j=0;j<subcol;j++)
        subset[i][j] = random(MAXNUM);
    }
  }

void allocateMemory(void)
  {
  unsigned int i;

  // Allocating Memory for SUPER-SET Matrix
  superset = (int**)malloc(suprow * sizeof(int));
  for(i=0;i<suprow;i++)
    superset[i] = (int*)malloc(supcol * sizeof(int));

  // Allocating Memory for SUB-SET Matrix
  subset = (int**)malloc(subrow * sizeof(int));
  for(i=0;i<subrow;i++)
    subset[i] = (int*)malloc(subcol * sizeof(int));

  // Allocating Memory for MATCH 1D Matrix
  match = (struct MatchMaking*)malloc(subrow * sizeof(struct MatchMaking));
  // Initializing with some default values
  for(i=0;i<subrow;i++)
    {
    match[i].subrowmatch = false;
    match[i].suprowindex = RESET;
    match[i].supcolstart = RESET;
    match[i].supcolend   = RESET;
    }
  }

void patMatch(void)
  {
  unsigned int i,j,p;
  bool supmattravel;

  for(i=0,p=0,supmattravel=INCOMPLETE ; i<suprow && p<subrow ; i=modIncr(i,SUP_ROW))
    {
    // Temporary Debugging Statements (TDS)
    /*
    printf("\n\n\nTDS-OUTER-LOOP: \t\t i = %d \t\t p = %d",i,p);
    //getch();
    */

    for(j=0; j<supcol /*&& suprowtravel = INCOMPLETE*/ ; j++)
      {
      // Temporary Debugging Statements (TDS)
      /*
      printf("\n\nTDS-INNER-LOOP: \t\t j = %d",j);
      //getch();
      */
      if(compareThreeElements(i,j,p))
        {
        if(p>0 && strictness && match[p-1].supcolstart != j)
          continue;

        match[p].subrowmatch = true;
        match[p].suprowindex = i;
        match[p].supcolstart = j;
        match[p].supcolend   = modIncr(j,SUP_COL,subcol-1);
        p++;

        // Temporary Debugging Statements (TDS)
        /*
        printf("\n\n\aTDS-SPECIAL-1: INNER LOOP Breaks!");
        getch();
        break;
        */
        }
      } // INNER J-LOOP ENDS

    if(modIncr(i,SUP_ROW) == 0)
      {
      // Temporary Debugging Statements
      /*
      printf("\n\n\aTDS-SPECIAL-2: j = %d",j);
      getch();
      */
      supmattravel = COMPLETE;
      if(p == 0)
        break;
      }
    else if(supmattravel == COMPLETE && i == (subrow-1)-1)
      {
      // Temporary Debugging Statements (TDS)
      /*
      printf("\n\n\aTDS-SPECIAL-1: OUTER LOOP Breaks!");
      getch();
      */
      break;
      }
    } // OUTER I&P-LOOP ENDS


  // DISPLAYING RESULTS OF PATTERN-MATCHING
  clrscr();
  printf("\n\n\a");
  if(p == subrow)
    printf("COMPLETE MATCH FOUND!!");
  else if(p == 0)
    {
    printf("ABSOLUTE MISS!! NO ROW MATCH!!");
    getch();
    return;
    }
  else
    printf("PARTIAL MATCH FOUND!!");
  getch();

  printf("\n\n\nDetails of the Match-Matrix is shown :  ");
  for(p=0; p<subrow; p++)
    {
    if(match[p].subrowmatch == true)
      {
      printf("\n\n\nSUB-SET ROW INDEX = %d \t\t SUPER-SET ROW INDEX = %d",p,match[p].suprowindex);
      printf(" \t\t SUPER-SET COL START = %d \t\t SUPER-SET COL END = %d",match[p].supcolstart,match[p].supcolend);
      printf("\n\n Matching Values Are: ");
      for(j=0;j<subcol;j++)
        printf(" \t\t%d",subset[p][j]);
      }
    }
  getch();
  }

bool compareThreeElements(unsigned int i,unsigned int j,unsigned int p)
  {
  if(superset[i][j] == subset[p][0] && superset[i][modIncr(j,SUP_COL)] == subset[p][1] && superset[i][modIncr(j,SUP_COL,2)] == subset[p][2])
    return true;
  return false;
  }

unsigned int modIncr(unsigned int num,unsigned int type,unsigned int incr)
  {
  num += incr;
  switch(type)
    {
    case SUP_ROW:
      num %= suprow;
      break;
    case SUP_COL:
      num %= supcol;
      break;
    case SUB_ROW:
      num %= subrow;
      break;
    case SUB_COL:
      num %= subcol;
      break;
    default:
      puts(NEVEREXEC);
      getch();
    }
  return num;
  }

// TEMPORARY STUB/DEBUGGING ROUTINES
// Remove these function definitions & associated function calls without
// changing core logic/functionality of the program
void dispMats(void)
  {
  unsigned int i,j;

  clrscr();
  // Displaying the SUPER-SET Matrix
  printf("SUPER-SET Matrix:\n\n");
  for(i=0;i<suprow;i++)
    {
    for(j=0;j<supcol;j++)
      printf("%d\t",superset[i][j]);
    printf("\n\n");
    }

  printf("\n\n\n\n");

  // Displaying the SUPER-SET Matrix
  printf("SUB-SET Matrix:\n\n");
  for(i=0;i<subrow;i++)
    {
    for(j=0;j<subcol;j++)
      printf("%d\t",subset[i][j]);
    printf("\n\n");
    }
  getch();
  }

void dispStub(char *desc)
  {
  clrscr();
  printf("This is a STUB for the Undeveloped Routine :  ");
  puts(desc);
  getch();
  }